﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ICSharpCode.SharpZipLib.Zip;
using PluginInterface;
using System.Windows.Forms;

namespace FVZipPlugin
{
    public class Class1 : IFVPlugin
    {
        TextBox textBox1 = new TextBox();
        
        #region IFVPlugin Member

        public void ChangedWindowSize()
        {
        }

        public void DisposeHandle()
        {
        }

        public List<string> GetFileextensions()
        {
            List<string> ret = new List<string>();
            ret.Add(".zip");
            return ret;
        }

        public void InitContainer(Panel ContentPanel, Panel ControlPanel)
        {
            ContentPanel.Controls.Add(textBox1);

            textBox1.Dock = DockStyle.Fill;
            textBox1.Multiline = true;
            textBox1.ReadOnly = true;
            textBox1.AutoSize = true;
            textBox1.ScrollBars = ScrollBars.Both;

            IsInit = true;
        }

        public bool IsInit
        { get; set; }

        public bool ShowFile(string path)
        {
            ZipFile file = new ZipFile(path);

            List<string> dirs = new List<string>();
            List<string> files = new List<string>();

            foreach(ZipEntry entry in file)
            {
                if (entry.IsDirectory)
                    dirs.Add(entry.Name);
                else if (entry.IsFile)
                    files.Add(entry.Name);
            }

            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Ordner:\n");

            foreach (string dir in dirs)
                sb.AppendLine(dir);

            sb.AppendLine("Dateien:\n");

            foreach (string filename in files)
                sb.AppendLine(filename);

            textBox1.Text = sb.ToString();
            textBox1.BringToFront();

            return true;
        }

        #endregion
    }
}
